import regex

from serializerLiza153501.serializer import serialize, deserialize
from serializerLiza153501.constants import ELEMENT_REGULAR

class serialize_XML:

    def dumps(self, objet):
        # print(objet)
        return self.convert_to_str(serialize(objet))

    def dump(self, objet, file):
        file.write(self.dumps(objet))

    def loads(self, string):
        # print (string)
        return deserialize(self.convert_to_expression(string))

    def load(self, file):
        return self.loads(file.read())

    def convert_to_str(self, obj):
        if isinstance(obj, (int, float, bool, complex)):
            return self._create_element(type(obj).__name__, str(obj))

        if isinstance(obj, str):
            return self._create_element("str", self._from_normal_symbol(obj))

        if isinstance(obj, list):
            value = "".join([self.convert_to_str(v) for v in obj])
            return self._create_element("list", value)

        if isinstance(obj, dict):
            value = "".join([f"{self.convert_to_str(k)}\
                                {self.convert_to_str(v)}" \
                             for k, v in obj.items()])
            return self._create_element("dict", value)

        if not obj:
            return self._cr